<script setup lang="ts">
import type { GOAnnotation } from "~/utils/types/goannotation";

const props = defineProps<{
  annotations: GOAnnotation[];
  dense?: boolean;
}>();

const aspects = [
  { id: "P", title: "Biological Process" },
  { id: "F", title: "Molecular Function" },
  { id: "C", title: "Cellular Component" },
] as const;

const tab = ref<string | null>(null);

const annotationMap = computed(() => {
  const res = {
    P: [],
    F: [],
    C: [],
  } as Record<"P" | "F" | "C", GOAnnotation[]>;
  props.annotations.forEach((item) => {
    if (item.term.aspect && Object.keys(res).includes(item.term.aspect)) {
      res[item.term.aspect].push(item);
    }
  });
  return res;
});

const sorted = (annos: GOAnnotation[]) => {
  return [...annos].sort((a, b) => {
    const aName = a.term.name;
    const bName = b.term.name;
    if (aName > bName) {
      return 1;
    } else if (aName < bName) {
      return -1;
    } else {
      return 0;
    }
  });
};

const uniq = (annos: GOAnnotation[]) => {
  const res: GOAnnotation[] = [];
  sorted(annos).forEach((anno, idx, arr) => {
    if (idx === 0 || anno.term.name !== arr[idx - 1].term.name) {
      res.push(anno);
    }
  });
  return res;
};
</script>

<template>
  <div class="d-flex flex-row">
    <v-tabs v-model="tab" show-arrows direction="vertical" color="primary">
      <v-tab v-for="aspect in aspects" :key="aspect.id" :value="aspect.id">
        <span>
          {{ aspect.title }}
        </span>
      </v-tab>
    </v-tabs>
    <v-window v-model="tab">
      <v-window-item
        v-for="aspect in aspects"
        :key="aspect.id"
        :value="aspect.id"
      >
        <NoDataText v-if="annotationMap[aspect.id].length === 0">
          No Gene Ontology annotations in this category.
        </NoDataText>
        <template v-else>
          <GOAnnotationItem
            v-for="anno in dense
              ? uniq(annotationMap[aspect.id])
              : sorted(annotationMap[aspect.id])"
            :key="anno.id"
            :annotation="anno"
            :dense="dense"
            class="ml-2"
          />
        </template>
      </v-window-item>
    </v-window>
  </div>
</template>
